require 'pp'
require File.expand_path(File.dirname(__FILE__) + '/rubicon_symbolic_lib')
#require File.expand_path(File.dirname(__FILE__) + '/rubicon_class_lib')
require File.expand_path(File.dirname(__FILE__) + '/rubicon_exp_lib')
require File.expand_path(File.dirname(__FILE__) + '/rubicon_rails_lib')
require File.expand_path(File.dirname(__FILE__) + '/rubicon_analyzer_lib')

$debug = false
$update_store = nil
$symbolic_execution = false
$object_num = 0
$objects_used = []
$defining_objects = false
$objects_fields = []
$fields = nil
$objects_map = nil
$lastest_objects = []
$strings = []
$used_assocs = {}

# should put this elsewhere
# class RSpec::Matchers::RespondTo
#   def initialize(meth)
#     @expected = meth
#     @name = "respond_to"
#   end
# end

def used_assoc(klass, name, klass_name)
  addition = name.to_s + ": set " + klass_name.to_s
  if $used_assocs[klass] and !$used_assocs[klass].include? addition then
    $used_assocs[klass] << addition
  else
    $used_assocs[klass] = [addition]
  end
end

def noot(arg)
  Exp_Not.new(arg)
end

class Shoulder
  def initialize(lhs, polarity)
    puts "making a shoulder: " + lhs.to_s
    @polarity = polarity
    @lhs = lhs
  end

  def ==(other)
    puts "called the equals: " + other.to_s
    $update_store << Exp_Call.new(@polarity, [@lhs, :==, other])
  end
end

class Object
#  alias :old_should :should
  alias :old_equals :==

  def self.forall(&block)
    # puts "no superclass with forall method"
    # puts "my class is " + self.to_s
    quantify(:forall, self, block)
  end

  def self.exists(&block)
    puts "no superclass with exists method"
    puts "my class is " + self.to_s
    quantify(:exists, self, block)
  end

  # def ==(arg)
  #   if $symbolic_execution then
  #     Exp_Call.new(:equals, [self, arg])
  #   else
  #     old_equals(arg)
  #   end
  # end

  def should(matcher = nil, message = nil)
#    puts matcher.class.to_s

    if $symbolic_execution then
      puts "IN SHOULD: " + matcher.class.to_s + ", " + message.class.to_s
#      if matcher.is_a? RSpec::Matchers::Matcher then
      if matcher == nil then
        Shoulder.new(self, :should)
      else
        # puts "name is " + matcher.instance_variable_get('@name').to_s + " and expected is " +  matcher.instance_variable_get('@expected').to_s
        # puts "rhs is " + self.to_s
        #$update_store << Exp_Call.new(:should, [self, matcher.instance_variable_get('@name'), matcher.instance_variable_get('@expected')])
        Exp_Call.new(:should, [self, matcher.instance_variable_get('@name'), matcher.instance_variable_get('@expected')])
      end
    else
      super
      #self.old_should(matcher, message)
    end
  end

  def should_not(matcher = nil, message = nil)
#    puts matcher.class.to_s

    if $symbolic_execution then
      puts "IN SHOULD_NOT: " + matcher.class.to_s + ", " + message.class.to_s
#      if matcher.is_a? RSpec::Matchers::Matcher then
      if matcher == nil then
        Shoulder.new(self, :should_not)
      else
        # puts "name is " + matcher.instance_variable_get('@name').to_s + " and expected is " +  matcher.instance_variable_get('@expected').to_s
        # puts "rhs is " + self.to_s
        #$update_store << Exp_Call.new(:should_not, [self, matcher.instance_variable_get('@name'), matcher.instance_variable_get('@expected')])
        Exp_Call.new(:should_not, [self, matcher.instance_variable_get('@name'), matcher.instance_variable_get('@expected')])
      end
    else
      super
      #self.old_should(matcher, message)
    end
  end


end


$gensym = 1
def run_block(klass, block)
  def mknew(n, k)
    if k == Integer then
      mknew(n, SymbInteger)
    else
      vars = []
      (1..n).each do
        vars << k.new
      end
      vars
    end
  end

  if block.arity == -1 then
    vars = []
    result = block.call
  elsif block.arity == 1 then
    vars = mknew(1, klass)
    result = block.call(vars[0])
  elsif block.arity == 2 then
    vars = mknew(2, klass)
    result = block.call(vars[0], vars[1])
  end


  vars.each do |v|
    metaklass = class << v; self; end

    name = "var" + $gensym.to_s
    $gensym = $gensym + 1

    metaklass.send(:define_method, :to_s, lambda { name })
  end

  $objects_used = $objects_used + vars
  $latest_objects = vars
  result
end

def quantify(typ, klass, block)

  def fix(name)
    if name == "String" then
      "MyString"
    else
      name.to_s
    end
  end

  if $symbolic_execution then
    result = run_block(klass, block)
    updates = $update_store
    $update_store = []
    return Exp_Quant.new(typ, klass, $latest_objects, (updates - [result]) + [result])
  else

    vars = eval("local_variables", block.binding)

    vars.each do |v|
      symbolic eval(v, block.binding)
    end

    symbolic_activerecord_classes

    $symbolic_execution = true
    $update_store = []
    $objects_used = []
    $strings = []
    $used_assocs = {}

    result = run_block(klass, block)
    puts "the result is " + result.to_s
    
    # puts '=================================================='
    # puts $update_store
    # puts '=================================================='
    # puts $objects_used
    # puts '**************************************************'

    my_update_store = $update_store
    $symbolic_execution = false
    $update_store = nil
    $symbolic_execution = false

  end

  objects_used = $objects_used
  properties = my_update_store

  puts "HERE IT IS ***************************"
  puts Exp_Quant.new(typ, klass, $latest_objects, result)

  quant = Exp_Quant.new(typ, klass, $latest_objects, my_update_store + [result])

  puts "the update store is " + my_update_store.to_s
  puts "and the result is " + result.to_s

  if my_update_store == [] and false then  ## yes this is bogus
    1.should == 1
  else
    alloy_code = ["sig MyString {}",
                  "sig Boolean {}",
                  "sig ID {}",
                  "sig Integer {}",
                  "sig Datetime {}",
                  "sig Date {}",
                  "sig Nilclass {}",
                  "sig Decimal {}"]

    $strings.each do |s|
      alloy_code << "one sig " + s + " extends MyString {}"
    end

    objects_used.each do |obj|
      # if obj.class == SymbolicRecord then
      #   k = obj.klass.new
      #   puts "THE OBJECTS ATTRIBUTES ARE " + k.attribute_names.map{|x| x.to_s}.join(", ")
      #   # puts "                        vs " + obj.attributes.map{|x| x.to_s}.join(", ")
      #   alloy_code << "sig " + k.class.to_s + "{"
      #   alloy_code << "  " + (["id: ID"] + 
      #                         (k.attribute_names.map{|x| x.to_s + ": " + 
      #                            fix(k.column_for_attribute(x).type.to_s.capitalize)})).join(", ")
      #   alloy_code << "}"
      if !([SymbInteger].include? obj.class) then
        #puts "THE OBJECTS ATTRIBUTES ARE " + obj.attribute_names.map{|x| x.to_s}.join(", ")
        # puts "                        vs " + obj.attributes.map{|x| x.to_s}.join(", ")
        alloy_code << "sig " + obj.class.to_s + "{"
        alloy_code << "  " + (["id: ID"] + 
                              (obj.attribute_names.map{|x| x.to_s + ": " + 
                                  fix(obj.column_for_attribute(x).type.to_s.capitalize)} +
                               if $used_assocs[obj.class] then $used_assocs[obj.class] else [] end)).join(", ")
        alloy_code << "}"
      end
    end

    alloy_code << "check {"
    alloy_code << quant.to_s
    alloy_code << "} for 5\n"

    puts alloy_code.join("\n")

    analyzer = Analyzer.new

    result = analyzer.analyze(objects_used, alloy_code.join("\n"), Hash.new)
    puts "THE RESULT IS " + result.to_s
    if result then
      1.should == 2
    else
      1.should == 1
    end

  end
end


def symbolic(obj)
#  puts "calling symbolic on " + obj.to_s
  if obj.is_a? Array then
    obj.each do |o|
      symbolic o
    end
  elsif !([Fixnum, Integer, Exp_Call, Exp_Var, Exp_Update, Exp_And, Exp_Or, Exp_Quant, Exp_Loop, Exp_ITE,
           #Sequence,
           Array, Hash, #RandIntObj, SymbObject, SymbInteger, SymbSeq, SymbString,
           Symbol, String, TrueClass, FalseClass].include? obj.class) and !(obj.instance_variable_defined?(:@symbolic)) then

    obj.instance_variable_set(:@symbolic, true)
    attrs = obj.instance_variables

    attrs.each do |attr|
      symbolic obj.instance_variable_get(attr)
      name = attr[1..-1]
      name_symb = name.to_sym
      name_setter_symb = (name + "=").to_sym

      current_number = $object_num

      redefine_method(obj, name_symb, lambda { Exp_Call.new(:field_get, [obj, name_symb]) })
      redefine_method(obj, name_setter_symb, lambda {|x| $update_store << Exp_Call.new(:field_set, [obj, name_symb, x])})
      redefine_method(obj, :to_s, lambda { if !($objects_used.include? self) then $objects_used << self end; obj.class.to_s + current_number.to_s })
      $object_num = $object_num + 1
    end
  end
  obj
end


def redefine_method(obj, name, block)
  metaclass = class << obj; self; end
  metaclass.send(:define_method, name, block)
end

def verify(&block)
  vars = eval("local_variables", block.binding)

  vars.each do |v|
    symbolic eval(v, block.binding)
  end

  $symbolic_execution = true
  $update_store = []
  $objects_used = []

  result = run_block(nil, block)

  # puts '=================================================='
  # puts $update_store
  # puts '=================================================='
  # puts $objects_used
  # puts '**************************************************'


  $symbolic_execution = false

  my_update_store = $update_store.map{|x| x.to_s}
  my_objs = $objects_used

  $update_store = nil

  decls = print_decls(my_objs, result)

  if $debug then
    puts "Declarations:"
    puts "********************************************************************************"
    puts decls
    puts "********************************************************************************"
    puts "Program:"
    puts "********************************************************************************"
    puts my_update_store
  else
    puts print_lts(decls, my_update_store)
  end

#  puts result
end

def print_lts(decls, program)
  '<LTS>
  <Declaration>' + decls +
    '</Declaration>
  <Processes>
    <Process Name="P1" Parameter="" Zoom="1" StateCounter="3">
      <States>
        <State Name="State 1" Init="True" Invariant="" IsUrgent="False" IsCommitted="False">
          <Position X="1" Y="1" Width="0.2" />
          <Label>
            <Position X="0.9" Y="1.3" Width="0.5" />
          </Label>
        </State>
        <State Name="State 2" Init="False" Invariant="" IsUrgent="False" IsCommitted="False">
          <Position X="2.4" Y="0.9" Width="0.2" />
          <Label>
            <Position X="2.31" Y="1.46" Width="0.5" />
          </Label>
        </State>
      </States>
      <Links>
        <Link>
          <From>State 1</From>
          <To>State 2</To>
          <Select>
          </Select>
          <Event>
          </Event>
          <ClockGuard>
          </ClockGuard>
          <Guard>true</Guard>
          <Program>' + program.join(";\n") + ";\n" +
'</Program>
          <ClockReset>
          </ClockReset>
          <Label>
            <Position X="1.8" Y="1" Width="0.25" />
          </Label>
        </Link>
      </Links>
    </Process>
  </Processes>
</LTS>'
end


def print_decls(myobjs, goal)
  output = []
  object_num = 0
#  $objects_fields = []
  $objects_map = Hash.new
  $fields = Hash.new

  $defining_objects = true

  myobjs.each do |obj|
    if obj.is_a? RandIntObj then
      output << "var " + obj.to_s + " : {" + obj.get_a.to_s + ".." + obj.get_b.to_s + "} = *;"
    else
      $objects_map[obj.to_s] = object_num

      vars = obj.instance_variables
      vars.delete("@symbolic")
      vars.each do |v|
        v_name = v[1..-1]
        if $fields[v_name] == nil then
          $fields[v_name] = []
        end

        $fields[v_name][object_num] = obj.instance_variable_get(v).to_s
      end

      output << "var " + obj.to_s + " = " + object_num.to_s + ";"

      object_num = object_num + 1
    end
  end

  $defining_objects = false

#  output << "var objects = [" + $objects_fields.join(", ") + "];"

  $fields.keys.each do |k|
    f_vals = $fields[k].map{|v| if v == nil then "-1" else v end}
    output << "var " + k + " = [" + f_vals.join(", ") + "];"
  end


  output << "#define goal (" + goal.to_s + ");"
  output << "Go = P1();"
  output << "#assert Go reaches goal;"

  output.join("\n")
end


def loop_until(condition, &block)
  backup = $update_store
  $update_store = []
  block.call
  new_stuff = $update_store
  $update_store = backup

  $update_store << Exp_Loop.new(condition, new_stuff)
end

def loop_while(condition, &block)
  backup = $update_store
  $update_store = []
  block.call
  new_stuff = $update_store
  $update_store = backup

  $update_store << Exp_Loop.new(condition, new_stuff)
end

def if_then_else(cond, t, e)
  Exp_ITE.new(cond, t, e)
end


def sleep(n)
  $update_store << Exp_Call.new(:skip, [])
end

def assert(e)
  e
end

def no_deadlock
  Exp_Call.new(:assert, [:no_deadlock])
end

def skip
  $update_store << Exp_Call.new(:skip, [])
end


def mnot(exp)
  Exp_Not.new(exp)
end
