################################################################################
# lib for rails support in rubicon
################################################################################

$VERBOSE = nil

class Class
  def descendants
    result = []
    ObjectSpace.each_object(Class) { |klass| result << klass if klass < self }
    result
  end

  def invariant(&block)
    klasses = ActiveRecord::Base.descendants

    klasses.each do |klass|
      assoc = klass.reflect_on_all_associations
      puts "assocs for " + klass.to_s
      assoc.each do |a|
        puts "   " + a.macro.to_s + " " + a.name.to_s
      end

    end

    quantify(:forall, self, block)
  end
end

# $gensym = 1

def symbolic_activerecord_classes

  Dir.glob(Rails.root.to_s + '/app/models/*.rb').each { |file| require file }
  klasses = ActiveRecord::Base.descendants


#  ObjectSpace.each_object(Class) {|klass| puts klass.to_s}

  puts "the classes are " + klasses.map{|x| x.to_s}.join(", ")

  klasses.each do |klass|
#    puts "for class " + klass.to_s + " the attributes are " + klass.attributes.to_s
    #puts "FOR CLASS " + klass.to_s + " the ASSOCIATIONS are " + klass.reflect_on_all_associations.map{|x| x.name.to_s + ": " + x.class_name.to_s}.join(", ")
    metaklass = class << klass; self; end
    #metaklass.send(:define_method, :new, lambda {|*args| if $symbolic_execution then SymbolicRecord.new(self) else super end})
    metaklass.send(:define_method, :my, lambda {|*args| if $symbolic_execution then SymbolicRecord.new(self) else super end})
    metaklass.send(:define_method, :find, lambda {|*args| if $symbolic_execution then mkSymbolicRecord(self) else super end})
    metaklass.send(:define_method, :except, lambda {|*args| if $symbolic_execution then SymbolicRecord.new(self) else super end})
    metaklass.send(:define_method, :all, lambda {|*args| if $symbolic_execution then SymbolicRecord.new(self) else super end})
    metaklass.send(:define_method, :where, lambda {|*args| if $symbolic_execution then SymbolicRecord.new(self) else super end})
    metaklass.send(:define_method, :find_by_id, lambda {|*args| if $symbolic_execution then SymbolicRecord.new(self) else super end})
#    metaklass.send(:define_method, :include?, lambda {|*args| if $symbolic_execution then Exp_Call.new(:include, [self, args[0]]) else super end})
#    metaklass.send(:define_method, :method_missing, lambda {|meth, *args| if $symbolic_execution then Exp_Call.new(:field_get, [self, meth]) else super end})
    metaklass.send(:define_method, :method_missing, lambda {|meth, *args| puts "CALLED ME " + meth.to_s; Exp_Call.new(:field_get, [self, meth])})
    
    klass.send(:define_method, :delete, lambda {|*args| if $symbolic_execution then puts "DELETING" else super end})
    klass.send(:define_method, :save, lambda {|*args| if $symbolic_execution then puts "SAVING" else super end})
    klass.send(:define_method, :attributes, lambda {|*args| if $symbolic_execution then SymbolicAttributes.new(self) else super end})

    # do I want attribute_names instead?
    klass.column_names.each do |name|
      #      puts "defining " + name + " on " + klass.to_s
      klass.send(:define_method, name.to_sym, lambda {|*args| if $symbolic_execution then Exp_Call.new(:field_get, [self, name.to_sym]) else super end})
      klass.send(:define_method, (name + "=").to_sym, lambda {|arg| puts "INSIDE"; if $symbolic_execution then 
                                                                      Exp_Call.new(:field_set, [self, name.to_sym, arg]) 
                                                                    else super end})
    end

    klass.reflect_on_all_associations.each do |assoc|
      klass.send(:define_method, assoc.name, lambda {|*args| if $symbolic_execution then 
                                                               used_assoc(klass, assoc.name, assoc.class_name)
                                                               Exp_Call.new(:field_get, [self, assoc.name]) 
                                                             else super end})
    end

    # name = "symbolicVar" + $gensym.to_s
    # $gensym = $gensym + 1

#    metaklass.send(:define_method, :to_s, lambda { name })
  end

end

def mkSymbolicRecord(klass)
  k = klass.new
  mk = class << k; k; end
  mk.send(:define_method, :to_s, lambda {|*args| if $symbolic_execution then klass.to_s else super end})
  k
end


class SymbolicRecord
  def initialize(klass)
    puts "new symbolic record with class " + klass.to_s
    @klass = klass
  end

  def klass
    @klass
  end

  def delete(*args)
    puts "DELETING HERE"
  end

  def method_missing(m, *args, &block)
    self
  end

  def select(&block)
    Exp_SetComp.new(self, block)
  end

  def my
    self
  end

  def find(id)
     puts "the id is " + id.to_s + " and its class is " + id.class.to_s
     puts "result is " + id.instance_variable_get(:@rands)[0].to_s
    id.instance_variable_get(:@rands)[0]
  end

  def include?(other)
    Exp_Call.new(:include, [self, other])
  end

  def to_s
    @klass.to_s
  end
end

class SymbolicAttributes
  def initialize(obj)
    @obj = obj
  end

  def method_missing(m, *args, &block)
    self
  end

  def to_s
    "attributes_of[" + @obj.to_s + "]"
  end
end

class Anything
  def initialize
    $gensym = $gensym + 1
    @name = "anything_var" + $gensym.to_s
  end

  def method_missing(meth, *args)
    Exp_Call.new(:field_get, [self, meth])
  end

  def to_s
    @name
  end
end

module Base64
end

# def Base64.decode64(arg)
#   arg
# end

def Marshal.load(arg)
  arg
end
