################################################################################
#
#  symbolic representatives for built-in ruby types, with methods that compose
#  expressions into larger expressions
#
################################################################################

class SymbInteger
  @@gensym = 1

  def initialize
    @name = "int_var_" + @@gensym.to_s
    @@gensym = @@gensym + 1
  end

  def even?
    Exp_Call.new(:even, [self])
  end

  def odd?
    Exp_Call.new(:odd, [self])
  end

  def +(arg)
    Exp_Call.new(:plus, [self, arg])
  end

  def ==(arg)
    Exp_Call.new(:equals, [self, arg])
  end

  def to_i
    self
  end

  def to_s
    @name
  end
end

class SymbString
  @@gensym = 1

  def initialize
    @name = "string_var_" + @@gensym.to_s
    @@gensym = @@gensym + 1
  end

  def ==(arg)
    Exp_Call.new(:equals, [self, arg])
  end

  def to_s
    @name
  end
end


class SymbSeq
  @@gensym = 1

  def initialize
    @name = "seq_var_" + @@gensym.to_s
    @@gensym = @@gensym + 1
  end

  def ==(arg)
    Exp_Call.new(:equals, [self, arg])
  end

  def to_s
    @name
  end

  def first
    Exp_Call.new(:first, [self])
  end

  def last
    Exp_Call.new(:last, [self])
  end

  def next(arg)
    Exp_Call.new(:next, [self, arg])
  end

  #todo:exists
  #also: is it right?
  def forall(&block)
    quantify(:forall, SymbObject, block)
  end
end


#todo -- what is it really? it's like a "blank unknown object"
class SymbObject
  def method_missing(meth, *args, &block)
    Exp_Call.new(meth, [self] + args)
  end
end
